

#define MY_RADIO_NRF24
#define MY_REPEATER_FEATURE
#include <SPI.h>
#include <MySensors.h>
boolean sensor;
boolean MysenSor;


#define SHIFTPWM_NOSPI                            
const int ShiftPWM_dataPin = 6;                   //  Do not change!!!
const int ShiftPWM_clockPin = 7;                  //  Do not change!!!
const int ShiftPWM_latchPin = 8;                  //  Do not change!!!
#include <ShiftPWM.h>
const bool ShiftPWM_invertOutputs = false;         
const bool ShiftPWM_balanceLoad = false;         
#define sensorLight_PIN A0                        // Light sensor  Do not change!!!
#define sensorBottom_PIN A1                       // Bottom sensor Do not change!!!                     
#define sensorUpper_PIN A2                        // Upper sensor  Do not change!!!
unsigned char maxBrightness = 100;                // Here you set the number of brightness levels. Adjust(0-255)!!
unsigned char pwmFrequency = 75;                  // These values affect the load of ShiftPWM 
unsigned int numRegisters = 3;                    // Number of shift registers Do not change!!!
unsigned int numOutputs = numRegisters * 8;
unsigned int numRGBLeds = numRegisters * 8 / 3;
unsigned int fadingMode = 0;                      // start with all LED's off.
boolean sensorUpperActive;
boolean sensorBottomActive;
int numberOfstairs=24;                           // Setup Number of Your stairs. Adjust up to 24 !!!!
int pause=30000;                                    // Setup delay ON/OFF  Adjust!!! 
byte faidoutSpeed=5;                              // How fast to fadeout     Adjust!!!
byte faidinSpeed=5;                               // How fast to fadein      Adjust!!!


void before() {
    MysenSor=loadState(sensor);                   // Set relay to last known state (using eeprom storage) 
 }
  
void presentation() { 
     present(sensor, S_LIGHT);
 }

void receive(const MyMessage &message) {          // We only expect one type of message from controller. But we better check anyway.
                                                     
  if (message.type==V_LIGHT) {
    MysenSor=message.getBool();
     // Store state in eeprom
     saveState(message.sensor, message.getBool());
  }
}
void setup() {


  
  ShiftPWM.SetAmountOfRegisters(numRegisters);
  ShiftPWM.Start(pwmFrequency, maxBrightness);
  pinMode(sensorBottom_PIN, INPUT);
  pinMode(sensorUpper_PIN, INPUT);
  pinMode(sensorLight_PIN, INPUT);
  
  
}


void loop() {

                               
  if  ( MysenSor!=0) {                             // Adjust photocell cencivity. (val<10 dark.....val>800 bright..)    !!!!!!!!
                                                   
    BottomTriggerFire();                           //Checking bottom sensor
    UpperTrigerFire();                             //Checking upper sensor
    switchONOFFfromdown();                         //Stairs on/off from down to up
    switchONOFFfromUp();                           //Stairs on/off from up to down
  }
}

void BottomTriggerFire() {

  if (analogRead (sensorBottom_PIN) >= 550 ) {      //Depend of the sensor type, if 0 when triggered ,than change the comparison to opposite value.
    sensorBottomActive = true;
  }
}

void UpperTrigerFire() {

  if (analogRead(sensorUpper_PIN) >= 550) {          //Depend of the sensor type, if 0 when triggered ,than change the comparison to opposite value.
    sensorUpperActive = true;
  }
}


void switchONOFFfromdown() {
  if (sensorBottomActive==true && sensorUpperActive==false){
    
 
        for(int i=0; i<numberOfstairs; i++){
          for(int a=0; a<maxBrightness; a++){
          ShiftPWM.SetOne(i,a);
          delay(faidoutSpeed);
           }
          }
          
        delay(pause); 

        for(int i=0; i<numberOfstairs; i++){
          for(int a=maxBrightness;a>=0;a--){
          ShiftPWM.SetOne(i,a);
          if(a==0){
          ShiftPWM.SetOne(i,0);  
          }
          delay(faidinSpeed);
           }
          }
        sensorBottomActive = false ;  
  }
}
         
 void switchONOFFfromUp () {
    if ( sensorUpperActive==true && sensorBottomActive==false) {


        for(int i=numberOfstairs; i>=0; i--){
          Serial.print(i);
          for(int a=0; a<maxBrightness; a++){
          ShiftPWM.SetOne(i,a);
          delay(faidoutSpeed);
           }
          }
          
        delay(pause); 

          
        for(int i=numberOfstairs; i>=0; i--){
          //Serial.print(i);
          for(int a=maxBrightness;a>=0;a--){
          ShiftPWM.SetOne(i,a);
          if(a==0){
          ShiftPWM.SetOne(i,0);  
          }
          delay(faidinSpeed);
           }
          }
        sensorUpperActive= false ;  
  }
}

     
    
    

        

  
